"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var useMatchMedia_1 = __importDefault(require("./useMatchMedia"));
var styles_1 = __importDefault(require("./styles"));
function useDarkMode(options) {
    if (options === void 0) { options = {}; }
    var _a = options.autodetect, autodetect = _a === void 0 ? true : _a, _b = options.defaultValue, defaultValue = _b === void 0 ? false : _b, _c = options.exceptions, exceptions = _c === void 0 ? [] : _c;
    var prefersDarkTheme = useMatchMedia_1.default("(prefers-color-scheme: dark)");
    var _d = React.useState(defaultValue), darkMode = _d[0], setDarkMode = _d[1];
    var setDarkThemeCallback = React.useCallback(function (t) {
        setDarkMode(t);
        try {
            localStorage.setItem("theme", JSON.stringify(t));
        }
        catch (e) {
            console.error(e);
        }
    }, [setDarkMode]);
    // Autodetect theme
    React.useEffect(function () {
        if (!autodetect) {
            return;
        }
        setDarkMode(prefersDarkTheme);
    }, [prefersDarkTheme]);
    // Try get stored preferences
    React.useEffect(function () {
        try {
            var preference = localStorage.getItem("theme");
            if (!preference) {
                return;
            }
            setDarkMode(preference === "true");
        }
        catch (e) {
        }
    }, []);
    // Apply theme changes
    React.useEffect(function () {
        if (typeof window === "undefined" || !darkMode) {
            return;
        }
        try {
            var stylesheet_1 = document.createElement("style");
            stylesheet_1.setAttribute("type", "text/css");
            stylesheet_1.innerHTML = styles_1.default(["img", ".no-dark-mode"].concat(exceptions));
            stylesheet_1.id = "react-hook-dark-mode-stylesheet";
            document.head.append(stylesheet_1);
            return function () {
                stylesheet_1.remove();
            };
        }
        catch (e) { }
    }, [darkMode]);
    return [darkMode, setDarkThemeCallback];
}
exports.default = useDarkMode;
//# sourceMappingURL=index.js.map